package dev.shadowsoffire.apotheosis.ench.enchantments.corrupted;

import java.util.Iterator;
import java.util.List;
import dev.shadowsoffire.apotheosis.adventure.compat.AdventureCuriosCompat;
import net.minecraftforge.fml.ModList;
import net.minecraft.util.Mth;
import net.minecraftforge.event.entity.living.LivingHealEvent;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.network.chat.Component;
import net.minecraft.world.item.enchantment.Enchantments;
import net.minecraftforge.common.ToolActions;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.enchantment.EnchantmentCategory;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.item.enchantment.Enchantment;

public class LifeMendingEnchant extends Enchantment
{
    private static final EquipmentSlot[] SLOTS;
    
    public LifeMendingEnchant() {
        super(Enchantment.Rarity.VERY_RARE, EnchantmentCategory.BREAKABLE, EquipmentSlot.values());
    }
    
    public int m_6183_(final int level) {
        return 65 + (level - 1) * 35;
    }
    
    public int m_6175_(final int level) {
        return this.m_6183_(level) + 50;
    }
    
    public int m_6586_() {
        return 3;
    }
    
    public boolean m_6589_() {
        return true;
    }
    
    public boolean canApplyAtEnchantingTable(final ItemStack stack) {
        return super.canApplyAtEnchantingTable(stack) || stack.canPerformAction(ToolActions.SHIELD_BLOCK);
    }
    
    protected boolean m_5975_(final Enchantment pOther) {
        return super.m_5975_(pOther) && pOther != Enchantments.f_44962_;
    }
    
    public Component m_44700_(final int level) {
        return (Component)((MutableComponent)super.m_44700_(level)).m_130940_(ChatFormatting.DARK_RED);
    }
    
    private boolean lifeMend(final LivingHealEvent e, final ItemStack stack) {
        if (stack.m_41619_() || !stack.m_41768_()) {
            return false;
        }
        final int level = stack.getEnchantmentLevel((Enchantment)this);
        if (level <= 0) {
            return false;
        }
        final float cost = 1.0f / (1 << level - 1);
        final int maxRestore = Math.min(Mth.m_14143_(e.getAmount() / cost), stack.m_41773_());
        e.setAmount(e.getAmount() - maxRestore * cost);
        stack.m_41721_(stack.m_41773_() - maxRestore);
        return true;
    }
    
    public void lifeMend(final LivingHealEvent e) {
        if (e.getEntity().m_9236_().f_46443_) {
            return;
        }
        final float amt = e.getAmount();
        if (amt <= 0.0f) {
            return;
        }
        for (final EquipmentSlot slot : LifeMendingEnchant.SLOTS) {
            final ItemStack stack = e.getEntity().m_6844_(slot);
            if (this.lifeMend(e, stack)) {
                return;
            }
        }
        if (ModList.get().isLoaded("curios")) {
            final List<ItemStack> stacks = AdventureCuriosCompat.getLifeMendingCurios(e.getEntity());
            for (final ItemStack stack2 : stacks) {
                if (this.lifeMend(e, stack2)) {
                    return;
                }
            }
        }
    }
    
    static {
        SLOTS = EquipmentSlot.values();
    }
}
